﻿#include <iostream>
#include <math.h>
#include <algorithm>
#include <vector>
#include <string>
#include <random>
#include <chrono>
#include <set>
#include <map>

using namespace std;

using i64 = long long;
using ld = long double;

template<typename T>
using vl = vector<T>;

template<typename T, typename G>
using pl = pair<T, G>;


template<typename T, typename G>
istream& operator>>(istream& in, pl<T, G>& a) {
	in >> a.first >> a.second;
	return in;
}

template<typename T, typename G>
ostream& operator<<(ostream& out, pair<T, G>& a) {
	out << a.first << ' ' << a.second;
	out << '\n';
	return out;
}

template<typename T>
istream& operator>>(istream& in, vl<T>& a) {
	for (auto& x : a)in >> x;
	return in;
}

template<typename T>
ostream& operator<<(ostream& out, vl<T>& a) {
	for (auto& x : a)out << x << ' ';
	out << '\n';
	return out;
}

vl<bool> used;
i64 s;

vl<vl<i64>> s1;
int h, w;
vl<bool> answer;
bool flag;
void rec(int index, i64 sum_now) {
	if (flag)return;
	if (index == used.size()) {

		if (sum_now == s) {
			answer.resize(used.size(), 0);
			copy(used.begin(), used.end(), answer.begin());
			flag = true;
		}
		return;
	}
	rec(index + 1, sum_now);
	used[index] = 1;
	int curr = w;
	i64 was = sum_now;
	if (index >= h)curr = h;
	for (int i = 0; i < curr; i++) {
		if (index < h) {
			if (used[h + i] == 0) { sum_now -= s1[index][i]; }
		}
		if (index >= h) {
			if (used[i] == 0) { sum_now -= s1[i][index - h]; }
		}
	}
	if (sum_now >= s)rec(index + 1, sum_now);
	used[index] = 0;
	sum_now = was;
}
void fun(int c) {
	vl<int> b(w);

	for (int i = 0; i < h; i++) {
		if ((~c >> i & 1) == 0) { continue; }
		for (int j = 0; j < w; j++) {
			b[j] += s1[i][j];
		}
	}
	vl<vl<int>> dp;
	vl<vl<int>> path;
	i64 su = 0;
	for (int i = 0; i < w; i++) { su += b[i]; }
	if (s > su)return;
	dp.resize(w + 1);
	path.resize(w + 1);
	for (int i = 0; i < w + 1; i++) {
		dp[i].resize(su + 1, -1);
		path[i].resize(su + 1, -1);
	}
	dp[0][0] = 1;
	path[0][0] = 0;
	for (int i = 1; i < w + 1; i++) {
		for (int j = 0; j < su + 1; j++) {
			if (dp[i - 1][j] != -1) {
				dp[i][j] = dp[i - 1][j];
				path[i][j] = 0;
			}
			if (j >= b[i - 1] && dp[i - 1][j - b[i - 1]] != -1) {
				dp[i][j] = dp[i - 1][j - b[i - 1]];
				path[i][j] = 1;

			}
		}
	}
	vl<int> path1;
	pl<int, int> curr = { w,s };
	if (dp[w][s] == -1)return;
	while (curr.first != 0 || curr.second != 0) {
		if (path[curr.first][curr.second] == 0) {
			curr = { curr.first - 1,curr.second };
		}
		else {
			path1.push_back(curr.first);
			curr = { curr.first - 1,curr.second - b[curr.first - 1] };
		}
	}
	vl<pl<int, int>> qqq;
	for (int i = 0; i < h; i++) {
		if (c >> i & (1)) { qqq.push_back({ 1, i + 1 }); }
	}
	set<int> asdc;
	for (auto x : path1) { asdc.insert(x); }
	for (int i = 1; i <= w; i++) {
		if (asdc.find(i) == asdc.end()) { qqq.push_back({ 2,i }); }
	}

	cout << "YES\n";
	cout << qqq.size() << '\n';
	for (auto x : qqq) { cout << x; }
	exit(0);
	return;
}


void solve() {
	cin >> h >> w;
	s1.resize(h);
	i64 all_sum = 0;
	bool is_very_good_pos = true;
	for (int i = 0; i < h; i++) {
		s1[i].resize(w);
		for (int j = 0; j < w; j++) {
			cin >> s1[i][j];
			all_sum += s1[i][j];
			if (s1[i][j] > 6)is_very_good_pos = false;
		}
	}
	cin >> s;
	if (is_very_good_pos) {
		for (int i = 0; i < (1 << h); i++) {
			fun(i);
		}
		cout << "NO";
		return;
	}
	used.resize(h + w);
	rec(0, all_sum);
	if (!flag) {
		cout << "NO";
		return;
	}
	cout << "YES\n";
	int k = 0;
	for (auto x : answer) { k += x; }
	cout << k << '\n';
	for (int i = 0; i < h; i++) {
		if (answer[i] == 1) { cout << 1 << ' ' << i + 1 << '\n'; }
	}
	for (int j = 0; j < w; j++) {
		if (answer[h + j])cout << 2 << ' ' << j + 1 << '\n';
	}



}


signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	i64 t = 1;
	//cin>>t;
	while (t--) { solve(); }
}