﻿#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <chrono>
#include <random>
using namespace std;


using i64 = long long;
using ld = long double;

template<typename T>
using vl = vector<T>;


template<typename T,typename G>
using pl = pair<T,G>;


template<typename T>
ostream& operator<<(ostream& out,vl<T> a) {
	for (auto x : a) out << x << ' ';
	out << '\n';
	return out;
}

template<typename T>
istream& operator>>(istream& in, vl<T>& a) {
	for (auto &x : a) in >> x;
	return in;
}


vl<int> s1, s2, s3;

i64 n, m;

i64 good(i64 k) {
	i64 ans = 0;
	for (int i = 0; i < n; i++) {
		if (k - s3[i] > 50)return 1e18;
		if (k >=s1[i]) {
			if (k >= s3[i]) {
				ans += (2ll << (k - s3[i]));
			}
			else { ans++; }
		}
	}
	
	return ans;
}


void solve() {
	cin >> n >> m;
	s1.resize(n);
	s2.resize(n);
	s3.resize(n);
	cin >> s1 >> s2;
	for (int i = 0; i < n; i++) {
		s3[i] = s1[i] + s2[i];
	}

	i64 l = -1, r = 1e18 + 1;
	while (r - l > 1) {
		i64 mid = (l + r) / 2;
		//cout << mid << ' ' << good(mid) << '\n';
		if (good(mid) >= m)r = mid;
		else l = mid;
	}
	if (good(r) == m)cout << r;
	else cout << -1;

}

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	while (t--) {
		solve();
	}
	
}
