﻿#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <chrono>
#include <random>
//#pragma GCC optimize('no-stack-protector')
using namespace std;



using i64 = long long;
using ld = long double;

template<typename T>
using vl = vector<T>;


template<typename T,typename G>
using pl = pair<T,G>;


template<typename T>
ostream& operator<<(ostream& out,vl<T> a) {
	for (auto x : a) out << x << ' ';
	out << '\n';
	return out;
}

template<typename T>
istream& operator>>(istream& in, vl<T>& a) {
	for (auto &x : a) in >> x;
	return in;
}
int n, m;

void solve() {
	cin >> n >> m;
	vl<int> s1(n);
	cin >> s1;
	vl<int> s2(m + 1);
	for (int i = 0; i < n; i++) {
		s2[s1[i] - 1]++;
	}
	if (m == 3) {

		if (s2[0] % 3 != s2[2] % 3 || s2[1] % 3 != s2[2] % 3){
			cout << 0;
			return;
		}
		int cnt = s1[0] % 3;
		s2[0] -= cnt;
		s2[1] -= cnt;
		s2[2] -= cnt;
		int k = min({ s2[0], s2[1], s2[2] });
		cout << k / 3 + 1 << '\n';
	}
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	i64 t = 1;
	while (t--) {
		solve();
	}
	
}
