﻿#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <chrono>
#include <random>
//#pragma GCC optimize('no-stack-protector')
using namespace std;



using i64 = long long;
using ld = long double;

template<typename T>
using vl = vector<T>;


template<typename T,typename G>
using pl = pair<T,G>;


template<typename T>
ostream& operator<<(ostream& out,vl<T> a) {
	for (auto x : a) out << x << ' ';
	out << '\n';
	return out;
}

template<typename T>
istream& operator>>(istream& in, vl<T>& a) {
	for (auto &x : a) in >> x;
	return in;
}
int n, m;

bool g3(vl<int>& s2) {
	for (int i = 0; i < s2.size(); i++) {
		if (s2[i] > 2)return false;
	}
	return true;

}

void solve() {
	cin >> n >> m;
	vl<int> s1(n);
	cin >> s1;
	vl<int> s2(m + 1);
	for (int i = 0; i < n; i++) {
		s2[s1[i] - 1]++;
	}
	if (m < 3) {
		for (int i = 0; i < m; i++) {
			if (s2[i] % 3 != 0) { cout << 0; return; }
		}
		cout << 1;
		return;
	}
	if (m == 3) {

		if (s2[0] % 3 != s2[2] % 3 || s2[1] % 3 != s2[2] % 3){
			cout << 0;
			return;
		}
		int cnt = s2[0] % 3;
		s2[0] -= cnt;
		s2[1] -= cnt;
		s2[2] -= cnt;
		int k = min({ s2[0], s2[1], s2[2] });
		cout << k / 3 + 1 << '\n';
		return;
	}
	if (m == 4) {
		int answer = 0;
		vl<int> t(4);
		for (int i = 0; i <= 5000; i++) {
			for (int j = 0; j <= 5000; j++) {
				t[0] = s2[0] - i;
				t[1] = s2[1] - i - j;
				t[2] = s2[2] - i - j;
				t[3] = s2[3] - j;

				int k = min({ t[0], t[1], t[2],t[3] });
				if (k < 0) { continue; }
				if (t[0] % 3 == 0 && t[1] % 3 == 0 && t[2] % 3 == 0 && t[2] % 3 == 0)answer++;
			}
		}
		cout << answer;
		return;
	}
	if (g3(s2)) {
		for (int i = 0; i < m-2; i++) {
			while (s2[i] > 0) {
				s2[i]--;
				s2[i + 1]--;
				s2[i + 2]--;
			}
			
		}
		for (int i = 0; i < m; i++) {
			if (s2[i] != 0) { cout << 0; return; }
		}
		cout << 1;
		return;
	}
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	i64 t = 1;
	while (t--) {
		solve();
	}
	
}
