﻿#include <iostream>
#include <math.h>
#include <algorithm>
#include <vector>
#include <string>
#include <random>
#include <chrono>
#include <set>
#include <map>

using namespace std;

using i64 = long long;
using ld = long double;

template<typename T>
using vl = vector<T>;

template<typename T,typename G>
using pl = pair<T, G>;


template<typename T, typename G>
istream& operator>>(istream& in, pl<T, G>& a) {
    in >> a.first >> a.second;
    return in;
}

template<typename T,typename G>
ostream& operator<<(ostream& out, pair<T,G>& a) {
    out << a.first << ' ' << a.second;
    out << '\n';
    return out;
}

template<typename T>
istream& operator>>(istream& in, vl<T> &a) {
    for (auto& x : a)in >> x;
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vl<T>& a) {
    for (auto& x : a)out << x << ' '; 
    out << '\n';
    return out;
}


void solve() {
    i64 n;
    cin >> n;
    vl<i64> s1(n);
    cin >> s1;
    i64 l = 0, r = 0;
    i64 cnt = 1;
    r = 0;
    i64 last_oper = 0;
    for (r=1; r < n; r++) {
        if (last_oper == 0) {
            if (s1[r] - s1[r - 1] == 0) {
                l = r;
            }
            if (s1[r] - s1[r - 1] > 0) {
                last_oper = 1;
            }
            if (s1[r] - s1[r - 1] < 0)last_oper = -1;
        }
        if (last_oper == 1){
            if (s1[r] == s1[r - 1]) { l = r;}
            if (s1[r] < s1[r - 1]) {
                last_oper = -1;
            }

        }
        if (last_oper == -1) {
            if (s1[r] == s1[r - 1]) { l = r; last_oper = 0; }
            if (s1[r] > s1[r - 1]) { l = r - 1; last_oper = 1; }
        }
        //cout << l << ' ' << r << '\n';
        cnt += r - l + 1;
    }
    cout << cnt;

}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    i64 t = 1;
    //cin>>t;
    while (t--) { solve(); }
}