﻿#include <iostream>
#include <math.h>
#include <algorithm>
#include <vector>
#include <string>
#include <random>
#include <chrono>
#include <set>
#include <map>

using namespace std;

using i64 = long long;
using ld = long double;

template<typename T>
using vl = vector<T>;

template<typename T, typename G>
using pl = pair<T, G>;


template<typename T, typename G>
istream& operator>>(istream& in, pl<T, G>& a) {
    in >> a.first >> a.second;
    return in;
}

template<typename T, typename G>
ostream& operator<<(ostream& out, pair<T, G>& a) {
    out << a.first << ' ' << a.second;
    out << '\n';
    return out;
}

template<typename T>
istream& operator>>(istream& in, vl<T>& a) {
    for (auto& x : a)in >> x;
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vl<T>& a) {
    for (auto& x : a)out << x << ' ';
    out << '\n';
    return out;
}

vl<bool> used;
i64 s;

vl<vl<i64>> s1;
int h, w;
vl<bool> answer;
bool flag;
void rec(int index, i64 sum_now) {
    if (flag)return;
    if (index == used.size()) {

        if (sum_now == s) {
            answer.resize(used.size(), 0);
            copy(used.begin(), used.end(), answer.begin());
            flag = true;
        }
        return;
    }
    rec(index + 1, sum_now);
    used[index] = 1;
    int curr = w;
    i64 was = sum_now;
    if (index >= h)curr = h;
    for (int i = 0; i < curr; i++) {
        if (index < h) {
            if (used[h + i] == 0) { sum_now -= s1[index][i]; }
        }
        if (index >= h) {
            if (used[i] == 0) { sum_now -= s1[i][index - h]; }
        }
    }
    if (sum_now >= s)rec(index + 1, sum_now);
    used[index] = 0;
    sum_now = was;
}

void solve() {
    cin >> h >> w;
    s1.resize(h);
    i64 all_sum = 0;
    for (int i = 0; i < h; i++) {
        s1[i].resize(w);
        for (int j = 0; j < w; j++) {
            cin >> s1[i][j];
            all_sum += s1[i][j];
        }
    }
    cin >> s;
    used.resize(h + w);
    rec(0, all_sum);
    if (!flag) {
        cout << "NO";
        return;
    }
    cout << "YES\n";
    int k = 0;
    for (auto x : answer) { k += x; }
    cout << k << '\n';
    for (int i = 0; i < h; i++) {
        if (answer[i] == 1) { cout << 1 << ' ' << i + 1 << '\n'; }
    }
    for (int j = 0; j < w; j++) {
        if (answer[h + j])cout << 2 << ' ' << j + 1 << '\n';
    }



}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    i64 t = 1;
    //cin>>t;
    while (t--) { solve(); }
}