﻿#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <chrono>
#include <random>
using namespace std;


using i64 = long long;
using ld = long double;

template<typename T>
using vl = vector<T>;


template<typename T,typename G>
using pl = pair<T,G>;


template<typename T>
ostream& operator<<(ostream& out,vl<T> a) {
	for (auto x : a) out << x << ' ';
	out << '\n';
	return out;
}

template<typename T>
istream& operator>>(istream& in, vl<T>& a) {
	for (auto &x : a) in >> x;
	return in;
}


vl<i64> s1;

void solve() {
	int n;
	cin >> n;
	s1.resize(n);
	cin >> s1;
	vl<i64> primary(1e6, 1);
	vl<i64> pr;
	for (i64 i = 2; i < primary.size(); i++) {
		if (!primary[i])continue;
		for (i64 j = i*i; j < primary.size(); j += i) {
			primary[j] = 0;
		}
		pr.push_back(i);
	}
	set<i64> di;
	vl<int> s2(n, 1);
	sort(s1.begin(), s1.end());
	for (int i = 0; i < n; i++) {
		bool flag = true;
		i64 ci = s1[i];
		for (int j = 0; j < pr.size(); j++) {
			if (pr[j] * pr[j] > s1[i])continue;
			if (s1[i] % pr[j] == 0) {
				if (di.find(s1[i] / pr[j]) != di.end()) { flag = false; }
				while (ci % pr[j] == 0)ci /= pr[j];
			}
		}
		if (di.find(s1[i] / ci) != di.end()) { flag = false; }
		if (flag) {
			di.insert(s1[i]);
			s2[i] = 2;
		}
	}
	cout << s2;
}

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t = 1;
	while (t--) {
		solve();
	}
	
}
